(*
 Funkcja liczy mimimum funkcji wielu zmiennych i zwraca modul gradientu
 nalezy zdefiniowac funkcje fnc(t) gdzie t jest wektorem, oraz wektor gradientu g(t)
 lambda jest skokiem skalujacym przesuwanie nowego punktu t,
 ftol jest tolerancja zbieznosci (iteracje sa przerywane gdy |g(t)|<ftol)
 maxiter jest maksymalna iloscia iteracji (gradmin zwraca ilosc zrobionych iteracji).
 Program nadrzedny musi miec zdefiniowany typ
   glnarray = ARRAY [1..dimension] OF extended;
*)
function GradMin(var t: glnarray; Norm:real; lambda: real; ftol: real; maxiter:integer): integer;
(* liczenie modulu gradientu: *)
 function GradientModule:real;
 var gm:real; ig:integer;
 begin
   gm:=0;
   grad(t,g);                {liczenie wektora gradientu}
   for ig:=1 to dimension do
    gm:=gm+sqr(g[ig]);
   GradientModule:=sqrt(gm);
 end; {GradientModule}
var it,iter: integer;
Begin {glowny podprogram}
  iter:=0;
{  DisplayP3D(t[1],0,fnc(t)*YMagnify,3); }
  {dopoki nie przekroczona ilosc iteracji oraz znormalizowany gradient<ftol}
  while (iter<=maxiter) and (GradientModule*Norm>ftol) do
   begin
     inc(iter);
     for it:=1 to dimension do
      t[it]:=t[it]-lambda*g[it]*Norm*(1.001-iter/maxiter);
if t[1]>2*Pi then t[1]:=t[1]-2*Pi
 else
  if t[1]<-2*Pi then t[1]:=t[1]+2*Pi;

if t[2]>2*Pi then t[2]:=t[2]-2*Pi
 else
  if t[2]<-2*Pi then t[2]:=t[2]+2*Pi;

{DisplayL3D(t[1],0,fnc(t)*YMagnify,1+ord(iter));}
   end;
  GradMin:=iter;
End;